package com.qmth.distributed.print.business.templete.push;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.qmth.boot.api.exception.ApiException;
import com.qmth.distributed.print.business.entity.TSyncExamLog;
import com.qmth.distributed.print.business.service.TSyncExamLogService;
import com.qmth.teachcloud.common.contant.SpringContextHolder;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.enums.TaskResultEnum;
import com.qmth.teachcloud.common.enums.TaskStatusEnum;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.Async;

import java.io.IOException;
import java.text.MessageFormat;
import java.util.Date;
import java.util.StringJoiner;

/**
 * @Description: 异步推送模板
 * @Author: CaoZixuan
 * @Date: 2021-10-31
 */
public abstract class AsyncPushTaskTemplate {
    private final static Logger log = LoggerFactory.getLogger(AsyncPushTaskTemplate.class);
    public static final String BEGIN_TITLE = "->开始准备处理同步的";
    public static final String EXCEPTION_TITLE = "->数据处理发生异常!";
    public static final String EXCEPTION_DATA = "错误信息:";
    public static final String FINISH_TITLE = "->数据处理结束，共需处理";
    public static final String SUCCESS_TITLE = "条数据，其中成功处理了";
    public static final String FINISH_SIZE = "条数据。";
    public static final String EXCEPTION_CREATE_TXT_TITLE = "->创建导出日志时发生异常!";

    /**
     * 异步导入任务
     *
     * @param tSyncExamLog
     * @return
     * @throws IOException
     */
    @Async
    public abstract Result pushTask(TSyncExamLog tSyncExamLog) throws Exception;

    /**
     * 创建txt文件
     *
     * @param tSyncExamLog
     */
    public void createTxt(TSyncExamLog tSyncExamLog) {
        try {
            JSONObject json = SystemConstant.createTxt(tSyncExamLog.getSummary());
            tSyncExamLog.setErrorFilePath(json.toJSONString());
        } catch (Exception e) {
            log.error(SystemConstant.LOG_ERROR, e);
            StringJoiner stringJoinerSummary = new StringJoiner("").add(tSyncExamLog.getSummary()).add("\n");
            stringJoinerSummary.add(MessageFormat.format("{0}{1}{2}{3}", DateUtil.format(new Date(), SystemConstant.DEFAULT_DATE_PATTERN), EXCEPTION_CREATE_TXT_TITLE, EXCEPTION_DATA, e.getMessage()));
            tSyncExamLog.setSummary(stringJoinerSummary.toString());
            tSyncExamLog.setResult(TaskResultEnum.ERROR);
            if (e instanceof ApiException) {
                ResultUtil.error((ApiException) e, e.getMessage());
            } else {
                ResultUtil.error(e.getMessage());
            }
        } finally {
            TSyncExamLogService tSyncExamLogService = SpringContextHolder.getBean(TSyncExamLogService.class);
            tSyncExamLog.setStatus(TaskStatusEnum.FINISH);
            tSyncExamLogService.updateById(tSyncExamLog);
        }
    }
}
